]>
Commit | Line | Data |
---|---|---|
1b1dce4b JS |
1 | #!/bin/sh |
2 | # | |
3 | # Copyright (c) 2006 Johannes E. Schindelin | |
4 | ||
5 | # SHORT DESCRIPTION | |
6 | # | |
7 | # This script makes it easy to fix up commits in the middle of a series, | |
8 | # and rearrange commits. | |
9 | # | |
10 | # The original idea comes from Eric W. Biederman, in | |
11 | # http://article.gmane.org/gmane.comp.version-control.git/22407 | |
12 | ||
1b1dce4b | 13 | . git-sh-setup |
1b1dce4b | 14 | |
80883bb3 MH |
15 | # The file containing rebase commands, comments, and empty lines. |
16 | # This file is created by "git rebase -i" then edited by the user. As | |
17 | # the lines are processed, they are removed from the front of this | |
6bb4e485 | 18 | # file and written to the tail of $done. |
431b7e78 | 19 | todo="$state_dir"/git-rebase-todo |
80883bb3 MH |
20 | |
21 | # The rebase command lines that have already been processed. A line | |
22 | # is moved here when it is first handled, before any associated user | |
23 | # actions. | |
431b7e78 | 24 | done="$state_dir"/done |
80883bb3 MH |
25 | |
26 | # The commit message that is planned to be used for any changes that | |
27 | # need to be committed following a user interaction. | |
431b7e78 | 28 | msg="$state_dir"/message |
80883bb3 MH |
29 | |
30 | # The file into which is accumulated the suggested commit message for | |
31 | # squash/fixup commands. When the first of a series of squash/fixups | |
32 | # is seen, the file is created and the commit message from the | |
33 | # previous commit and from the first squash/fixup commit are written | |
34 | # to it. The commit message for each subsequent squash/fixup commit | |
35 | # is appended to the file as it is processed. | |
36 | # | |
37 | # The first line of the file is of the form | |
6bb4e485 MZ |
38 | # # This is a combination of $count commits. |
39 | # where $count is the number of commits whose messages have been | |
80883bb3 MH |
40 | # written to the file so far (including the initial "pick" commit). |
41 | # Each time that a commit message is processed, this line is read and | |
42 | # updated. It is deleted just before the combined commit is made. | |
431b7e78 | 43 | squash_msg="$state_dir"/message-squash |
80883bb3 | 44 | |
a25eb139 MH |
45 | # If the current series of squash/fixups has not yet included a squash |
46 | # command, then this file exists and holds the commit message of the | |
47 | # original "pick" commit. (If the series ends without a "squash" | |
48 | # command, then this can be used as the commit message of the combined | |
49 | # commit without opening the editor.) | |
431b7e78 | 50 | fixup_msg="$state_dir"/message-fixup |
a25eb139 | 51 | |
6bb4e485 MZ |
52 | # $rewritten is the name of a directory containing files for each |
53 | # commit that is reachable by at least one merge base of $head and | |
54 | # $upstream. They are not necessarily rewritten, but their children | |
80883bb3 MH |
55 | # might be. This ensures that commits on merged, but otherwise |
56 | # unrelated side branches are left alone. (Think "X" in the man page's | |
57 | # example.) | |
431b7e78 | 58 | rewritten="$state_dir"/rewritten |
80883bb3 | 59 | |
431b7e78 | 60 | dropped="$state_dir"/dropped |
0aac0de4 MH |
61 | |
62 | # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and | |
63 | # GIT_AUTHOR_DATE that will be used for the commit that is currently | |
64 | # being rebased. | |
431b7e78 | 65 | author_script="$state_dir"/author-script |
0aac0de4 | 66 | |
a4049ae7 MH |
67 | # When an "edit" rebase command is being processed, the SHA1 of the |
68 | # commit to be edited is recorded in this file. When "git rebase | |
69 | # --continue" is executed, if there are any staged changes then they | |
70 | # will be amended to the HEAD commit, but only provided the HEAD | |
71 | # commit is still the commit to be edited. When any other rebase | |
72 | # command is processed, this file is deleted. | |
431b7e78 | 73 | amend="$state_dir"/amend |
a4049ae7 | 74 | |
b079feed TR |
75 | # For the post-rewrite hook, we make a list of rewritten commits and |
76 | # their new sha1s. The rewritten-pending list keeps the sha1s of | |
77 | # commits that have been processed, but not committed yet, | |
78 | # e.g. because they are waiting for a 'squash' command. | |
431b7e78 MZ |
79 | rewritten_list="$state_dir"/rewritten-list |
80 | rewritten_pending="$state_dir"/rewritten-pending | |
6bb4e485 | 81 | |
89c7ae9c | 82 | GIT_CHERRY_PICK_HELP="$resolvemsg" |
804c7174 WC |
83 | export GIT_CHERRY_PICK_HELP |
84 | ||
1b1dce4b | 85 | warn () { |
938791cd | 86 | printf '%s\n' "$*" >&2 |
1b1dce4b JS |
87 | } |
88 | ||
ee0a4afb MH |
89 | # Output the commit message for the specified commit. |
90 | commit_message () { | |
91 | git cat-file commit "$1" | sed "1,/^$/d" | |
92 | } | |
93 | ||
6bb4e485 | 94 | orig_reflog_action="$GIT_REFLOG_ACTION" |
1b1dce4b JS |
95 | |
96 | comment_for_reflog () { | |
6bb4e485 | 97 | case "$orig_reflog_action" in |
1b1dce4b JS |
98 | ''|rebase*) |
99 | GIT_REFLOG_ACTION="rebase -i ($1)" | |
100 | export GIT_REFLOG_ACTION | |
376ccb8c | 101 | ;; |
1b1dce4b JS |
102 | esac |
103 | } | |
104 | ||
4e673877 | 105 | last_count= |
1b1dce4b | 106 | mark_action_done () { |
6bb4e485 MZ |
107 | sed -e 1q < "$todo" >> "$done" |
108 | sed -e 1d < "$todo" >> "$todo".new | |
109 | mv -f "$todo".new "$todo" | |
110 | new_count=$(sane_grep -c '^[^#]' < "$done") | |
111 | total=$(($new_count+$(sane_grep -c '^[^#]' < "$todo"))) | |
112 | if test "$last_count" != "$new_count" | |
4e673877 | 113 | then |
6bb4e485 MZ |
114 | last_count=$new_count |
115 | printf "Rebasing (%d/%d)\r" $new_count $total | |
116 | test -z "$verbose" || echo | |
4e673877 | 117 | fi |
1b1dce4b JS |
118 | } |
119 | ||
120 | make_patch () { | |
4fb1a19d JS |
121 | sha1_and_parents="$(git rev-list --parents -1 "$1")" |
122 | case "$sha1_and_parents" in | |
123 | ?*' '?*' '?*) | |
124 | git diff --cc $sha1_and_parents | |
125 | ;; | |
126 | ?*' '?*) | |
127 | git diff-tree -p "$1^!" | |
128 | ;; | |
129 | *) | |
130 | echo "Root commit" | |
131 | ;; | |
431b7e78 | 132 | esac > "$state_dir"/patch |
6bb4e485 MZ |
133 | test -f "$msg" || |
134 | commit_message "$1" > "$msg" | |
135 | test -f "$author_script" || | |
136 | get_author_ident_from_commit "$1" > "$author_script" | |
1b1dce4b JS |
137 | } |
138 | ||
139 | die_with_patch () { | |
431b7e78 | 140 | echo "$1" > "$state_dir"/stopped-sha |
1b1dce4b | 141 | make_patch "$1" |
ecfe72ff | 142 | git rerere |
1b1dce4b JS |
143 | die "$2" |
144 | } | |
145 | ||
c54b7817 | 146 | die_abort () { |
431b7e78 | 147 | rm -rf "$state_dir" |
c54b7817 JS |
148 | die "$1" |
149 | } | |
150 | ||
376ccb8c | 151 | has_action () { |
e1622bfc | 152 | sane_grep '^[^#]' "$1" >/dev/null |
376ccb8c JS |
153 | } |
154 | ||
7756ecff MH |
155 | # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and |
156 | # GIT_AUTHOR_DATE exported from the current environment. | |
157 | do_with_author () { | |
76c9c0db JH |
158 | ( |
159 | export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE | |
160 | "$@" | |
161 | ) | |
7756ecff MH |
162 | } |
163 | ||
1b1dce4b | 164 | pick_one () { |
8e75abfd CC |
165 | ff=--ff |
166 | case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac | |
6bb4e485 | 167 | case "$force_rebase" in '') ;; ?*) ff= ;; esac |
dfa49f33 | 168 | output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1" |
6bb4e485 | 169 | test -d "$rewritten" && |
f09c9b8c | 170 | pick_one_preserving_merges "$@" && return |
8e75abfd | 171 | output git cherry-pick $ff "$@" |
1b1dce4b JS |
172 | } |
173 | ||
f09c9b8c | 174 | pick_one_preserving_merges () { |
71d9451e TR |
175 | fast_forward=t |
176 | case "$1" in | |
177 | -n) | |
178 | fast_forward=f | |
179 | sha1=$2 | |
180 | ;; | |
181 | *) | |
182 | sha1=$1 | |
183 | ;; | |
184 | esac | |
f09c9b8c JS |
185 | sha1=$(git rev-parse $sha1) |
186 | ||
431b7e78 | 187 | if test -f "$state_dir"/current-commit |
f09c9b8c | 188 | then |
4c1360f4 | 189 | if test "$fast_forward" = t |
bb645071 | 190 | then |
41f556b9 | 191 | while read current_commit |
bb645071 | 192 | do |
6bb4e485 | 193 | git rev-parse HEAD > "$rewritten"/$current_commit |
431b7e78 MZ |
194 | done <"$state_dir"/current-commit |
195 | rm "$state_dir"/current-commit || | |
bb645071 SH |
196 | die "Cannot write current commit's replacement sha1" |
197 | fi | |
f09c9b8c JS |
198 | fi |
199 | ||
431b7e78 | 200 | echo $sha1 >> "$state_dir"/current-commit |
a96dc01e | 201 | |
f09c9b8c | 202 | # rewrite parents; if none were rewritten, we can fast-forward. |
f09c9b8c | 203 | new_parents= |
d911d146 TR |
204 | pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)" |
205 | if test "$pend" = " " | |
206 | then | |
207 | pend=" root" | |
208 | fi | |
faae853c | 209 | while [ "$pend" != "" ] |
f09c9b8c | 210 | do |
faae853c SH |
211 | p=$(expr "$pend" : ' \([^ ]*\)') |
212 | pend="${pend# $p}" | |
213 | ||
6bb4e485 | 214 | if test -f "$rewritten"/$p |
f09c9b8c | 215 | then |
6bb4e485 | 216 | new_p=$(cat "$rewritten"/$p) |
80fe82e4 SH |
217 | |
218 | # If the todo reordered commits, and our parent is marked for | |
219 | # rewriting, but hasn't been gotten to yet, assume the user meant to | |
220 | # drop it on top of the current HEAD | |
221 | if test -z "$new_p" | |
222 | then | |
223 | new_p=$(git rev-parse HEAD) | |
224 | fi | |
225 | ||
f09c9b8c JS |
226 | test $p != $new_p && fast_forward=f |
227 | case "$new_parents" in | |
228 | *$new_p*) | |
229 | ;; # do nothing; that parent is already there | |
230 | *) | |
231 | new_parents="$new_parents $new_p" | |
376ccb8c | 232 | ;; |
f09c9b8c | 233 | esac |
1c5fa0a1 | 234 | else |
6bb4e485 | 235 | if test -f "$dropped"/$p |
faae853c SH |
236 | then |
237 | fast_forward=f | |
6bb4e485 | 238 | replacement="$(cat "$dropped"/$p)" |
d911d146 TR |
239 | test -z "$replacement" && replacement=root |
240 | pend=" $replacement$pend" | |
faae853c SH |
241 | else |
242 | new_parents="$new_parents $p" | |
243 | fi | |
f09c9b8c JS |
244 | fi |
245 | done | |
246 | case $fast_forward in | |
247 | t) | |
a75d7b54 | 248 | output warn "Fast-forward to $sha1" |
71d9451e | 249 | output git reset --hard $sha1 || |
a75d7b54 | 250 | die "Cannot fast-forward to $sha1" |
f09c9b8c JS |
251 | ;; |
252 | f) | |
376ccb8c | 253 | first_parent=$(expr "$new_parents" : ' \([^ ]*\)') |
a4f25e36 SH |
254 | |
255 | if [ "$1" != "-n" ] | |
256 | then | |
257 | # detach HEAD to current parent | |
258 | output git checkout $first_parent 2> /dev/null || | |
259 | die "Cannot move HEAD to $first_parent" | |
260 | fi | |
f09c9b8c | 261 | |
f09c9b8c | 262 | case "$new_parents" in |
376ccb8c | 263 | ' '*' '*) |
a4f25e36 SH |
264 | test "a$1" = a-n && die "Refusing to squash a merge: $sha1" |
265 | ||
f09c9b8c | 266 | # redo merge |
6bb4e485 MZ |
267 | author_script_content=$(get_author_ident_from_commit $sha1) |
268 | eval "$author_script_content" | |
269 | msg_content="$(commit_message $sha1)" | |
f91333d6 BS |
270 | # No point in merging the first parent, that's HEAD |
271 | new_parents=${new_parents# $first_parent} | |
7756ecff | 272 | if ! do_with_author output \ |
9fdc1cc8 | 273 | git merge --no-ff ${strategy:+-s $strategy} -m \ |
9765b6ab | 274 | "$msg_content" $new_parents |
f09c9b8c | 275 | then |
6bb4e485 | 276 | printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG |
f5b49ea6 | 277 | die_with_patch $sha1 "Error redoing merge $sha1" |
f09c9b8c | 278 | fi |
6bb4e485 | 279 | echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list" |
f09c9b8c JS |
280 | ;; |
281 | *) | |
2a9c53e0 | 282 | output git cherry-pick "$@" || |
f09c9b8c | 283 | die_with_patch $sha1 "Could not pick $sha1" |
376ccb8c | 284 | ;; |
f09c9b8c | 285 | esac |
376ccb8c | 286 | ;; |
f09c9b8c JS |
287 | esac |
288 | } | |
289 | ||
6368f3f8 JS |
290 | nth_string () { |
291 | case "$1" in | |
292 | *1[0-9]|*[04-9]) echo "$1"th;; | |
293 | *1) echo "$1"st;; | |
294 | *2) echo "$1"nd;; | |
295 | *3) echo "$1"rd;; | |
296 | esac | |
297 | } | |
298 | ||
a25eb139 | 299 | update_squash_messages () { |
6bb4e485 MZ |
300 | if test -f "$squash_msg"; then |
301 | mv "$squash_msg" "$squash_msg".bak || exit | |
302 | count=$(($(sed -n \ | |
f99e269c | 303 | -e "1s/^# This is a combination of \(.*\) commits\./\1/p" \ |
6bb4e485 | 304 | -e "q" < "$squash_msg".bak)+1)) |
bde1a686 | 305 | { |
6bb4e485 | 306 | echo "# This is a combination of $count commits." |
bde1a686 MH |
307 | sed -e 1d -e '2,/^./{ |
308 | /^$/d | |
6bb4e485 MZ |
309 | }' <"$squash_msg".bak |
310 | } >"$squash_msg" | |
6368f3f8 | 311 | else |
6bb4e485 MZ |
312 | commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg" |
313 | count=2 | |
bde1a686 MH |
314 | { |
315 | echo "# This is a combination of 2 commits." | |
316 | echo "# The first commit's message is:" | |
317 | echo | |
6bb4e485 MZ |
318 | cat "$fixup_msg" |
319 | } >"$squash_msg" | |
6368f3f8 | 320 | fi |
0205e72f MH |
321 | case $1 in |
322 | squash) | |
6bb4e485 | 323 | rm -f "$fixup_msg" |
0205e72f | 324 | echo |
6bb4e485 | 325 | echo "# This is the $(nth_string $count) commit message:" |
0205e72f | 326 | echo |
ee0a4afb | 327 | commit_message $2 |
0205e72f MH |
328 | ;; |
329 | fixup) | |
330 | echo | |
6bb4e485 | 331 | echo "# The $(nth_string $count) commit message will be skipped:" |
0205e72f | 332 | echo |
ee0a4afb | 333 | commit_message $2 | sed -e 's/^/# /' |
0205e72f | 334 | ;; |
6bb4e485 | 335 | esac >>"$squash_msg" |
6368f3f8 JS |
336 | } |
337 | ||
338 | peek_next_command () { | |
6bb4e485 | 339 | sed -n -e "/^#/d" -e '/^$/d' -e "s/ .*//p" -e "q" < "$todo" |
6368f3f8 JS |
340 | } |
341 | ||
6bdcd0d2 MH |
342 | # A squash/fixup has failed. Prepare the long version of the squash |
343 | # commit message, then die_with_patch. This code path requires the | |
344 | # user to edit the combined commit message for all commits that have | |
345 | # been squashed/fixedup so far. So also erase the old squash | |
346 | # messages, effectively causing the combined commit to be used as the | |
347 | # new basis for any further squash/fixups. Args: sha1 rest | |
348 | die_failed_squash() { | |
6bb4e485 MZ |
349 | mv "$squash_msg" "$msg" || exit |
350 | rm -f "$fixup_msg" | |
351 | cp "$msg" "$GIT_DIR"/MERGE_MSG || exit | |
6bdcd0d2 MH |
352 | warn |
353 | warn "Could not apply $1... $2" | |
354 | die_with_patch $1 "" | |
355 | } | |
356 | ||
b079feed | 357 | flush_rewritten_pending() { |
6bb4e485 | 358 | test -s "$rewritten_pending" || return |
b079feed | 359 | newsha1="$(git rev-parse HEAD^0)" |
6bb4e485 MZ |
360 | sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list" |
361 | rm -f "$rewritten_pending" | |
b079feed TR |
362 | } |
363 | ||
364 | record_in_rewritten() { | |
365 | oldsha1="$(git rev-parse $1)" | |
6bb4e485 | 366 | echo "$oldsha1" >> "$rewritten_pending" |
b079feed TR |
367 | |
368 | case "$(peek_next_command)" in | |
41f556b9 | 369 | squash|s|fixup|f) |
b079feed | 370 | ;; |
41f556b9 | 371 | *) |
b079feed TR |
372 | flush_rewritten_pending |
373 | ;; | |
374 | esac | |
375 | } | |
376 | ||
1b1dce4b | 377 | do_next () { |
6bb4e485 MZ |
378 | rm -f "$msg" "$author_script" "$amend" || exit |
379 | read -r command sha1 rest < "$todo" | |
1b1dce4b | 380 | case "$command" in |
ff74126c | 381 | '#'*|''|noop) |
1b1dce4b | 382 | mark_action_done |
1b1dce4b | 383 | ;; |
f8babc4d | 384 | pick|p) |
1b1dce4b JS |
385 | comment_for_reflog pick |
386 | ||
387 | mark_action_done | |
388 | pick_one $sha1 || | |
389 | die_with_patch $sha1 "Could not apply $sha1... $rest" | |
b079feed | 390 | record_in_rewritten $sha1 |
1b1dce4b | 391 | ;; |
6741aa6c BG |
392 | reword|r) |
393 | comment_for_reflog reword | |
394 | ||
395 | mark_action_done | |
396 | pick_one $sha1 || | |
397 | die_with_patch $sha1 "Could not apply $sha1... $rest" | |
6f6bee3b | 398 | git commit --amend --no-post-rewrite |
b079feed | 399 | record_in_rewritten $sha1 |
6741aa6c | 400 | ;; |
f8babc4d | 401 | edit|e) |
1b1dce4b JS |
402 | comment_for_reflog edit |
403 | ||
404 | mark_action_done | |
405 | pick_one $sha1 || | |
406 | die_with_patch $sha1 "Could not apply $sha1... $rest" | |
431b7e78 | 407 | echo "$sha1" > "$state_dir"/stopped-sha |
1b1dce4b | 408 | make_patch $sha1 |
6bb4e485 | 409 | git rev-parse --verify HEAD > "$amend" |
a8ccc204 | 410 | warn "Stopped at $sha1... $rest" |
1b1dce4b JS |
411 | warn "You can amend the commit now, with" |
412 | warn | |
413 | warn " git commit --amend" | |
414 | warn | |
0460fb44 JS |
415 | warn "Once you are satisfied with your changes, run" |
416 | warn | |
417 | warn " git rebase --continue" | |
418 | warn | |
1b1dce4b JS |
419 | exit 0 |
420 | ;; | |
0205e72f MH |
421 | squash|s|fixup|f) |
422 | case "$command" in | |
423 | squash|s) | |
424 | squash_style=squash | |
425 | ;; | |
426 | fixup|f) | |
427 | squash_style=fixup | |
428 | ;; | |
429 | esac | |
430 | comment_for_reflog $squash_style | |
1b1dce4b | 431 | |
6bb4e485 | 432 | test -f "$done" && has_action "$done" || |
0205e72f | 433 | die "Cannot '$squash_style' without a previous commit" |
1b1dce4b JS |
434 | |
435 | mark_action_done | |
a25eb139 | 436 | update_squash_messages $squash_style $sha1 |
6bb4e485 MZ |
437 | author_script_content=$(get_author_ident_from_commit HEAD) |
438 | echo "$author_script_content" > "$author_script" | |
439 | eval "$author_script_content" | |
7c418836 | 440 | output git reset --soft HEAD^ |
6bdcd0d2 | 441 | pick_one -n $sha1 || die_failed_squash $sha1 "$rest" |
6368f3f8 | 442 | case "$(peek_next_command)" in |
0205e72f | 443 | squash|s|fixup|f) |
a25eb139 MH |
444 | # This is an intermediate commit; its message will only be |
445 | # used in case of trouble. So use the long version: | |
6bb4e485 | 446 | do_with_author output git commit --no-verify -F "$squash_msg" || |
6bdcd0d2 | 447 | die_failed_squash $sha1 "$rest" |
376ccb8c | 448 | ;; |
6368f3f8 | 449 | *) |
a25eb139 | 450 | # This is the final command of this squash/fixup group |
6bb4e485 | 451 | if test -f "$fixup_msg" |
a25eb139 | 452 | then |
6bb4e485 | 453 | do_with_author git commit --no-verify -F "$fixup_msg" || |
6bdcd0d2 MH |
454 | die_failed_squash $sha1 "$rest" |
455 | else | |
6bb4e485 | 456 | cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit |
6bdcd0d2 MH |
457 | rm -f "$GIT_DIR"/MERGE_MSG |
458 | do_with_author git commit --no-verify -e || | |
459 | die_failed_squash $sha1 "$rest" | |
a25eb139 | 460 | fi |
6bb4e485 | 461 | rm -f "$squash_msg" "$fixup_msg" |
376ccb8c | 462 | ;; |
6368f3f8 | 463 | esac |
b079feed | 464 | record_in_rewritten $sha1 |
1b1dce4b | 465 | ;; |
cd035b1c | 466 | x|"exec") |
6bb4e485 | 467 | read -r command rest < "$todo" |
cd035b1c MM |
468 | mark_action_done |
469 | printf 'Executing: %s\n' "$rest" | |
470 | # "exec" command doesn't take a sha1 in the todo-list. | |
471 | # => can't just use $sha1 here. | |
431b7e78 | 472 | git rev-parse --verify HEAD > "$state_dir"/stopped-sha |
cd035b1c MM |
473 | ${SHELL:-@SHELL_PATH@} -c "$rest" # Actual execution |
474 | status=$? | |
475 | if test "$status" -ne 0 | |
476 | then | |
477 | warn "Execution failed: $rest" | |
478 | warn "You can fix the problem, and then run" | |
479 | warn | |
480 | warn " git rebase --continue" | |
481 | warn | |
482 | exit "$status" | |
483 | fi | |
484 | # Run in subshell because require_clean_work_tree can die. | |
92c62a3f | 485 | if ! (require_clean_work_tree "rebase") |
cd035b1c MM |
486 | then |
487 | warn "Commit or stash your changes, and then run" | |
488 | warn | |
489 | warn " git rebase --continue" | |
490 | warn | |
491 | exit 1 | |
492 | fi | |
493 | ;; | |
1b1dce4b JS |
494 | *) |
495 | warn "Unknown command: $command $sha1 $rest" | |
f1be316a JK |
496 | if git rev-parse --verify -q "$sha1" >/dev/null |
497 | then | |
6bb4e485 | 498 | die_with_patch $sha1 "Please fix this in the file $todo." |
f1be316a | 499 | else |
6bb4e485 | 500 | die "Please fix this in the file $todo." |
f1be316a | 501 | fi |
376ccb8c | 502 | ;; |
1b1dce4b | 503 | esac |
6bb4e485 | 504 | test -s "$todo" && return |
1b1dce4b | 505 | |
68a163c9 | 506 | comment_for_reflog finish && |
2959c283 | 507 | shortonto=$(git rev-parse --short $onto) && |
6bb4e485 | 508 | newhead=$(git rev-parse HEAD) && |
431b7e78 | 509 | case $head_name in |
73697a0b | 510 | refs/*) |
431b7e78 MZ |
511 | message="$GIT_REFLOG_ACTION: $head_name onto $shortonto" && |
512 | git update-ref -m "$message" $head_name $newhead $orig_head && | |
53f2ffa8 JK |
513 | git symbolic-ref \ |
514 | -m "$GIT_REFLOG_ACTION: returning to $head_name" \ | |
515 | HEAD $head_name | |
73697a0b JS |
516 | ;; |
517 | esac && { | |
431b7e78 | 518 | test ! -f "$state_dir"/verbose || |
2959c283 | 519 | git diff-tree --stat $orig_head..HEAD |
3df0a859 | 520 | } && |
eb2151bb | 521 | { |
6bb4e485 MZ |
522 | test -s "$rewritten_list" && |
523 | git notes copy --for-rewrite=rebase < "$rewritten_list" || | |
eb2151bb TR |
524 | true # we don't care if this copying failed |
525 | } && | |
b079feed | 526 | if test -x "$GIT_DIR"/hooks/post-rewrite && |
6bb4e485 MZ |
527 | test -s "$rewritten_list"; then |
528 | "$GIT_DIR"/hooks/post-rewrite rebase < "$rewritten_list" | |
b079feed TR |
529 | true # we don't care if this hook failed |
530 | fi && | |
431b7e78 | 531 | rm -rf "$state_dir" && |
73697a0b | 532 | git gc --auto && |
431b7e78 | 533 | warn "Successfully rebased and updated $head_name." |
1b1dce4b JS |
534 | |
535 | exit | |
536 | } | |
537 | ||
538 | do_rest () { | |
539 | while : | |
540 | do | |
541 | do_next | |
542 | done | |
1b1dce4b JS |
543 | } |
544 | ||
0e757e30 JS |
545 | # skip picking commits whose parents are unchanged |
546 | skip_unnecessary_picks () { | |
547 | fd=3 | |
2d6ca6ef | 548 | while read -r command rest |
0e757e30 JS |
549 | do |
550 | # fd=3 means we skip the command | |
2d6ca6ef BC |
551 | case "$fd,$command" in |
552 | 3,pick|3,p) | |
6bb4e485 | 553 | # pick a commit whose parent is current $onto -> skip |
14d87298 | 554 | sha1=${rest%% *} |
2d6ca6ef | 555 | case "$(git rev-parse --verify --quiet "$sha1"^)" in |
6bb4e485 MZ |
556 | "$onto"*) |
557 | onto=$sha1 | |
2d6ca6ef BC |
558 | ;; |
559 | *) | |
560 | fd=1 | |
561 | ;; | |
562 | esac | |
0e757e30 | 563 | ;; |
2d6ca6ef | 564 | 3,#*|3,) |
0e757e30 JS |
565 | # copy comments |
566 | ;; | |
567 | *) | |
568 | fd=1 | |
569 | ;; | |
570 | esac | |
d1c3b10f | 571 | printf '%s\n' "$command${rest:+ }$rest" >&$fd |
6bb4e485 MZ |
572 | done <"$todo" >"$todo.new" 3>>"$done" && |
573 | mv -f "$todo".new "$todo" && | |
b079feed TR |
574 | case "$(peek_next_command)" in |
575 | squash|s|fixup|f) | |
6bb4e485 | 576 | record_in_rewritten "$onto" |
b079feed TR |
577 | ;; |
578 | esac || | |
0e757e30 JS |
579 | die "Could not skip unnecessary pick commands" |
580 | } | |
581 | ||
f59baa50 NS |
582 | # Rearrange the todo list that has both "pick sha1 msg" and |
583 | # "pick sha1 fixup!/squash! msg" appears in it so that the latter | |
584 | # comes immediately after the former, and change "pick" to | |
585 | # "fixup"/"squash". | |
586 | rearrange_squash () { | |
68d5d03b KB |
587 | # extract fixup!/squash! lines and resolve any referenced sha1's |
588 | while read -r pick sha1 message | |
589 | do | |
590 | case "$message" in | |
591 | "squash! "*|"fixup! "*) | |
592 | action="${message%%!*}" | |
593 | rest="${message#*! }" | |
594 | echo "$sha1 $action $rest" | |
595 | # if it's a single word, try to resolve to a full sha1 and | |
596 | # emit a second copy. This allows us to match on both message | |
597 | # and on sha1 prefix | |
598 | if test "${rest#* }" = "$rest"; then | |
599 | fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)" | |
600 | if test -n "$fullsha"; then | |
601 | # prefix the action to uniquely identify this line as | |
602 | # intended for full sha1 match | |
603 | echo "$sha1 +$action $fullsha" | |
604 | fi | |
605 | fi | |
606 | esac | |
607 | done >"$1.sq" <"$1" | |
f59baa50 NS |
608 | test -s "$1.sq" || return |
609 | ||
610 | used= | |
57f2b6b2 | 611 | while read -r pick sha1 message |
f59baa50 NS |
612 | do |
613 | case " $used" in | |
614 | *" $sha1 "*) continue ;; | |
615 | esac | |
938791cd | 616 | printf '%s\n' "$pick $sha1 $message" |
d3d7a421 | 617 | used="$used$sha1 " |
6bb4e485 | 618 | while read -r squash action msg_content |
f59baa50 | 619 | do |
d3d7a421 KB |
620 | case " $used" in |
621 | *" $squash "*) continue ;; | |
622 | esac | |
68d5d03b KB |
623 | emit=0 |
624 | case "$action" in | |
625 | +*) | |
626 | action="${action#+}" | |
627 | # full sha1 prefix test | |
6bb4e485 | 628 | case "$msg_content" in "$sha1"*) emit=1;; esac ;; |
68d5d03b KB |
629 | *) |
630 | # message prefix test | |
6bb4e485 | 631 | case "$message" in "$msg_content"*) emit=1;; esac ;; |
68d5d03b KB |
632 | esac |
633 | if test $emit = 1; then | |
6bb4e485 | 634 | printf '%s\n' "$action $squash $action! $msg_content" |
f59baa50 | 635 | used="$used$squash " |
68d5d03b | 636 | fi |
f59baa50 NS |
637 | done <"$1.sq" |
638 | done >"$1.rearranged" <"$1" | |
639 | cat "$1.rearranged" >"$1" | |
640 | rm -f "$1.sq" "$1.rearranged" | |
641 | } | |
642 | ||
cf432ca0 MZ |
643 | case "$action" in |
644 | continue) | |
cf432ca0 MZ |
645 | # do we have anything to commit? |
646 | if git diff-index --cached --quiet --ignore-submodules HEAD -- | |
647 | then | |
648 | : Nothing to commit -- skip this | |
649 | else | |
650 | . "$author_script" || | |
651 | die "Cannot find the author identity" | |
652 | current_head= | |
653 | if test -f "$amend" | |
03270628 | 654 | then |
cf432ca0 MZ |
655 | current_head=$(git rev-parse --verify HEAD) |
656 | test "$current_head" = $(cat "$amend") || | |
657 | die "\ | |
c14c3c82 DP |
658 | You have uncommitted changes in your working tree. Please, commit them |
659 | first and then run 'git rebase --continue' again." | |
cf432ca0 MZ |
660 | git reset --soft HEAD^ || |
661 | die "Cannot rewind the HEAD" | |
03270628 | 662 | fi |
cf432ca0 MZ |
663 | do_with_author git commit --no-verify -F "$msg" -e || { |
664 | test -n "$current_head" && git reset --soft $current_head | |
665 | die "Could not commit staged changes." | |
666 | } | |
667 | fi | |
18640d99 | 668 | |
431b7e78 | 669 | record_in_rewritten "$(cat "$state_dir"/stopped-sha)" |
0acb62f2 | 670 | |
cf432ca0 MZ |
671 | require_clean_work_tree "rebase" |
672 | do_rest | |
673 | ;; | |
cf432ca0 | 674 | skip) |
cf432ca0 | 675 | git rerere clear |
cf432ca0 | 676 | |
2959c283 | 677 | do_rest |
cf432ca0 MZ |
678 | ;; |
679 | esac | |
1b1dce4b | 680 | |
34262322 MZ |
681 | git var GIT_COMMITTER_IDENT >/dev/null || |
682 | die "You need to set your committer info first" | |
1b1dce4b | 683 | |
34262322 MZ |
684 | comment_for_reflog start |
685 | ||
71786f54 | 686 | if test ! -z "$switch_to" |
34262322 | 687 | then |
71786f54 MZ |
688 | output git checkout "$switch_to" -- || |
689 | die "Could not checkout $switch_to" | |
34262322 MZ |
690 | fi |
691 | ||
431b7e78 MZ |
692 | orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?" |
693 | mkdir "$state_dir" || die "Could not create temporary $state_dir" | |
34262322 | 694 | |
431b7e78 | 695 | : > "$state_dir"/interactive || die "Could not mark as interactive" |
84df4560 | 696 | write_basic_state |
6bb4e485 | 697 | if test t = "$preserve_merges" |
34262322 | 698 | then |
6bb4e485 | 699 | if test -z "$rebase_root" |
34262322 | 700 | then |
6bb4e485 | 701 | mkdir "$rewritten" && |
431b7e78 | 702 | for c in $(git merge-base --all $orig_head $upstream) |
acc8559a | 703 | do |
6bb4e485 | 704 | echo $onto > "$rewritten"/$c || |
34262322 | 705 | die "Could not init rewritten commits" |
acc8559a | 706 | done |
34262322 | 707 | else |
6bb4e485 MZ |
708 | mkdir "$rewritten" && |
709 | echo $onto > "$rewritten"/root || | |
34262322 MZ |
710 | die "Could not init rewritten commits" |
711 | fi | |
712 | # No cherry-pick because our first pass is to determine | |
713 | # parents to rewrite and skipping dropped commits would | |
714 | # prematurely end our probe | |
6bb4e485 | 715 | merges_option= |
431b7e78 | 716 | first_after_upstream="$(git rev-list --reverse --first-parent $upstream..$orig_head | head -n 1)" |
34262322 | 717 | else |
6bb4e485 | 718 | merges_option="--no-merges --cherry-pick" |
34262322 MZ |
719 | fi |
720 | ||
431b7e78 | 721 | shorthead=$(git rev-parse --short $orig_head) |
6bb4e485 MZ |
722 | shortonto=$(git rev-parse --short $onto) |
723 | if test -z "$rebase_root" | |
724 | # this is now equivalent to ! -z "$upstream" | |
34262322 | 725 | then |
6bb4e485 | 726 | shortupstream=$(git rev-parse --short $upstream) |
431b7e78 | 727 | revisions=$upstream...$orig_head |
6bb4e485 | 728 | shortrevisions=$shortupstream..$shorthead |
34262322 | 729 | else |
431b7e78 | 730 | revisions=$onto...$orig_head |
6bb4e485 | 731 | shortrevisions=$shorthead |
34262322 | 732 | fi |
6bb4e485 | 733 | git rev-list $merges_option --pretty=oneline --abbrev-commit \ |
34262322 | 734 | --abbrev=7 --reverse --left-right --topo-order \ |
6bb4e485 | 735 | $revisions | \ |
34262322 MZ |
736 | sed -n "s/^>//p" | |
737 | while read -r shortsha1 rest | |
738 | do | |
6bb4e485 | 739 | if test t != "$preserve_merges" |
34262322 | 740 | then |
6bb4e485 | 741 | printf '%s\n' "pick $shortsha1 $rest" >> "$todo" |
34262322 MZ |
742 | else |
743 | sha1=$(git rev-parse $shortsha1) | |
6bb4e485 | 744 | if test -z "$rebase_root" |
acc8559a | 745 | then |
34262322 MZ |
746 | preserve=t |
747 | for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-) | |
acc8559a | 748 | do |
6bb4e485 | 749 | if test -f "$rewritten"/$p -a \( $p != $onto -o $sha1 = $first_after_upstream \) |
acc8559a | 750 | then |
34262322 | 751 | preserve=f |
acc8559a SH |
752 | fi |
753 | done | |
34262322 MZ |
754 | else |
755 | preserve=f | |
756 | fi | |
757 | if test f = "$preserve" | |
758 | then | |
6bb4e485 MZ |
759 | touch "$rewritten"/$sha1 |
760 | printf '%s\n' "pick $shortsha1 $rest" >> "$todo" | |
acc8559a | 761 | fi |
34262322 MZ |
762 | fi |
763 | done | |
d911d146 | 764 | |
34262322 | 765 | # Watch for commits that been dropped by --cherry-pick |
6bb4e485 | 766 | if test t = "$preserve_merges" |
34262322 | 767 | then |
6bb4e485 | 768 | mkdir "$dropped" |
34262322 | 769 | # Save all non-cherry-picked changes |
6bb4e485 | 770 | git rev-list $revisions --left-right --cherry-pick | \ |
431b7e78 | 771 | sed -n "s/^>//p" > "$state_dir"/not-cherry-picks |
34262322 MZ |
772 | # Now all commits and note which ones are missing in |
773 | # not-cherry-picks and hence being dropped | |
6bb4e485 | 774 | git rev-list $revisions | |
34262322 MZ |
775 | while read rev |
776 | do | |
431b7e78 | 777 | if test -f "$rewritten"/$rev -a "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = "" |
34262322 MZ |
778 | then |
779 | # Use -f2 because if rev-list is telling us this commit is | |
780 | # not worthwhile, we don't want to track its multiple heads, | |
781 | # just the history of its first-parent for others that will | |
782 | # be rebasing on top of it | |
6bb4e485 | 783 | git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev |
34262322 | 784 | short=$(git rev-list -1 --abbrev-commit --abbrev=7 $rev) |
6bb4e485 MZ |
785 | sane_grep -v "^[a-z][a-z]* $short" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo" |
786 | rm "$rewritten"/$rev | |
34262322 MZ |
787 | fi |
788 | done | |
789 | fi | |
790 | ||
6bb4e485 MZ |
791 | test -s "$todo" || echo noop >> "$todo" |
792 | test -n "$autosquash" && rearrange_squash "$todo" | |
793 | cat >> "$todo" << EOF | |
6047a234 | 794 | |
6bb4e485 | 795 | # Rebase $shortrevisions onto $shortonto |
1b1dce4b JS |
796 | # |
797 | # Commands: | |
88b1f0b8 | 798 | # p, pick = use commit |
6741aa6c | 799 | # r, reword = use commit, but edit the commit message |
88b1f0b8 MV |
800 | # e, edit = use commit, but stop for amending |
801 | # s, squash = use commit, but meld into previous commit | |
0205e72f | 802 | # f, fixup = like "squash", but discard this commit's log message |
960ac5ff | 803 | # x, exec = run command (the rest of the line) using shell |
82576ddb JS |
804 | # |
805 | # If you remove a line here THAT COMMIT WILL BE LOST. | |
6047a234 | 806 | # However, if you remove everything, the rebase will be aborted. |
82576ddb | 807 | # |
1b1dce4b | 808 | EOF |
1b1dce4b | 809 | |
6bb4e485 | 810 | has_action "$todo" || |
34262322 | 811 | die_abort "Nothing to do" |
1b1dce4b | 812 | |
6bb4e485 MZ |
813 | cp "$todo" "$todo".backup |
814 | git_editor "$todo" || | |
34262322 | 815 | die_abort "Could not execute editor" |
1b1dce4b | 816 | |
6bb4e485 | 817 | has_action "$todo" || |
34262322 | 818 | die_abort "Nothing to do" |
c54b7817 | 819 | |
6bb4e485 | 820 | test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks |
0e757e30 | 821 | |
6bb4e485 | 822 | output git checkout $onto || die_abort "could not detach HEAD" |
431b7e78 | 823 | git update-ref ORIG_HEAD $orig_head |
34262322 | 824 | do_rest |